#include <iostream>

using namespace std;

const int MAX_N = 400005;
int N, T[MAX_N];

bool CzyPlusJestMozliwy(int ramie)
{
  // Bedziemy utrzymywali jaką długość poprawnego okienka jesteśmy w stanie
  // utrzymać.
  int dlugosc_poprawnego_okienka = 0;

  // Iterujemy się po wszystkich wieżowcach.
  for (int wiezowiec : T)
  {
    // Jeśli mamy już całą lewą stronę okienka, sprawdzamy czy
    // środkowy wieżowiec ma odpowiednią wysokość na środkową
    // część plusa.
    if (dlugosc_poprawnego_okienka == ramie)
    {
      if (wiezowiec >= 2 * ramie + 1)
      {
        dlugosc_poprawnego_okienka++;
      }
      // Jeżeli wieżowiec jest mniejszy niż długość ramienia plusa,
      // to musimy zacząć nasze okienko od nowa.
      else if (wiezowiec <= ramie)
      {
        dlugosc_poprawnego_okienka = 0;
      }
    }
    // Jeżeli nie musimy obsłużyć środka, to sprawdzamy tylko
    // czy wieżowiec ma co najmniej wysokość ramie + 1.
    else
    {
      if (wiezowiec >= ramie + 1)
      {
        dlugosc_poprawnego_okienka++;
      }
      else
      {
        dlugosc_poprawnego_okienka = 0;
      }
    }

    // Jeśli mamy całe okienko o rozmiarze 2 * ramie + 1, to możemy tutaj
    // zostawić plusa.
    if (dlugosc_poprawnego_okienka >= 2 * ramie + 1)
    {
      return true;
    }
  }

  return false;
}

int main()
{
  ios_base::sync_with_stdio(0);

  cin >> N;
  for (int i = 0; i < N; ++i)
    cin >> T[i];

  // Używamy algorytmu wyszukiwania binarnego
  // aby znaleźć maksymalną wielkość plusa.
  int lewy = 0, prawy = (N + 1) / 2;
  while (prawy - lewy > 1)
  {
    int srodek = (lewy + prawy) / 2;
    if (CzyPlusJestMozliwy(srodek))
      lewy = srodek;
    else
      prawy = srodek;
  }
  cout << lewy << "\n";
}
